//---------------------------------------------------------------------------
//Open GL framework with help from Eike Anderson
//---------------------------------------------------------------------------


#include <GL/glut.h> // enough to deal with opening window
#include "screen.h"
#include "calc.h"
#include <iostream>
using namespace std; // using c++

//-----------------------------------------------------------------------------

screen myScreen;
int iScreenWidth=800;  //never go over 1000, see array size
int iScreenHight=800;  //never go over 1000, see array size
CCalculation myCalc;

//-----------------------------------------------------------------------------

void preset(void);  // declare function for settings of window
void display(void); // declare function for displaying window

//-----------------------------------------------------------------------------



int main(int argc, char *argv[]) // commandline arguments because of glut s. next
{
  //dialog to set user defined variables
 cout<<endl;
 cout<<endl;
 cout<<"----------------------------------------------"<<endl;
 cout<<"--Welcome to Tina's tests on fractal flames.--"<<endl;
 cout<<"----------------------------------------------"<<endl;
 cout<<endl;
 cout<<endl;
 cout<<"Please choose the number of iterations"<<endl;
 cout<<"(recommended between 100000 and 100000000,"<<endl;
 cout<<"for the colours 'rainbow' and 'all blues' even more)."<<endl;
 cout<<endl;
 cin>>myCalc.iIterations;
 cout<<endl;
 cout<<endl;
 cout<<"Please choose a pattern from the following list:"<<endl;
 cout<<"1 - Sierpinsky's Triangle, functions by Scott Draves."<<endl;
 cout<<"2 - Cloud-like , example by Scott Draves."<<endl;
 cout<<"3 - linear & spiral & swirl , example by Scott Draves."<<endl;
 cout<<"4 - Tina's try out 1."<<endl;
 cout<<"5 - Tina's try out 2."<<endl;
 cout<<"The following are the original functions provided by Scott Draves."<<endl;
 cout<<"The used coefficients are taken from the above examples."<<endl;
 cout<<"These functions are not meant to be used separately,"<<endl;
 cout<<"so the result is not very pleasing."<<endl;
 cout<<"6 - Scott Drave's - linear -."<<endl;
 cout<<"7 - Scott Drave's - sinusoidal -."<<endl;
 cout<<"8 - Scott Drave's - spherical -."<<endl;
 cout<<"9 - Scott Drave's - swirl -."<<endl;
 cout<<"10 - Scott Drave's - horseshoe -."<<endl;
 cout<<"11 - Scott Drave's - polar -."<<endl;
 cout<<"12 - Scott Drave's - handkerchief -."<<endl;
 cout<<"13 - Scott Drave's - heart -."<<endl;
 cout<<"14 - Scott Drave's - disc -."<<endl;
 cout<<"15 - Scott Drave's - spiral -."<<endl;
 cout<<"16 - Scott Drave's - hyperbolic -."<<endl;
 cout<<"17 - Scott Drave's - diamond -."<<endl;
 cout<<"18 - Scott Drave's - ex -."<<endl;
 cout<<"19 - Scott Drave's - fisheye -."<<endl;
 cout<<"20 - Scott Drave's - cosine -."<<endl;
 cout<<endl;
 cin>>myCalc.iPattern;
 cout<<endl;
 cout<<endl;
 cout<<"Please choose the type of colouring from the following list:"<<endl;
 cout<<"1 - Black & white."<<endl;
 cout<<"2 - Logarithmic grey scale."<<endl;
 cout<<"3 - Traffic light colours."<<endl;
 cout<<"4 - Rainbow colours."<<endl;
 cout<<"5 - All blues."<<endl;
 cout<<endl;
 cin>>myCalc.iColourType;
 cout<<endl;
 cout<<endl;



 glutInit(&argc,argv); // pass in the addresses of the command-line argumets
 glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA); // Double-Buffered because calculating and drawing at same time,

 glutInitWindowSize(iScreenWidth,iScreenHight); //square for later -1 - +1 left - right, up - down
 glutInitWindowPosition(100,50);
 glutCreateWindow("Tina's Fractal Flame Test");

 glutDisplayFunc(display); // call the display function

 preset();

 myCalc.initCalculate(); //do the calculation once

 glutMainLoop(); // enter event loop

 return 0;
}



void preset(void)
{
  glClearColor(0.0,0.0,0.0,0.0); // set "background" colour to black
  glViewport(0,0,iScreenWidth,iScreenHight); // set viewport of 600x600 in middle of window
  glMatrixMode(GL_PROJECTION);  // set projection matrix
  glLoadIdentity(); // reset to Identity Matrix
  gluOrtho2D(0.0,iScreenWidth,0.0,iScreenHight); // create 2D projection matrix, cause don't need 3D
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  //"beauty", so that the drawn pixel is really "in the middle" of the screen pixel
  glTranslatef(0.375,0.375,0.0);
}



void display(void)
{
  glClear(GL_COLOR_BUFFER_BIT); // "clear board" before drawing
  preset();

  myScreen.drawScreen(); //draw what has been calculated

  glFlush(); // draw on screen
  glutSwapBuffers(); // swap because double buffers, not necessary in single buffer
}


